{#-#####################################################################
 # Jinja2 template for /etc/network/interfaces
 #======================================================================
 # Helper macros for ifupdown configuration generation
 ####################################################################-#}
{#======================================================================
 # Get stanza device
 #----------------------------------------------------------------------
 # Returns the device name to mention in a stanza. This macros is used
 # to build <parent_device>.<vlan_id> interface names for vlan
 # interfaces.
 #===================================================================-#}
{%- macro get_stanza_device(interface, indexes) -%}
  {%- if interface['type'] == 'vlan' -%}
    {%- set parent_device =
        config.get_device_name_from_interface_uid(
          interface['vlan']['parent'],
          indexes) -%}
    {{ parent_device ~ "." ~ interface['vlan']['index'] | int }}
  {%- else -%}
    {{ config.get_device_name_from_interface(interface, indexes) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Render stanza
 #----------------------------------------------------------------------
 # Render a single stanza from supplied data.
 #===================================================================-#}
{%- macro render_stanza(device, family, method, lines=[], desc="") -%}
  {{ "iface " ~ device ~ " " ~ family ~ " " ~ method ~ "\n" }}

  {%- if lines -%}
    {{ lines | join("\n") ~ "\n" }}
  {%- endif -%}

  {%- if desc -%}
    {{ "#" ~ desc ~ "\n" }}
  {%- endif -%}
{%- endmacro -%}
